Index: netwerk/cookie/src/nsCookieService.cpp
===================================================================
RCS file: /cvsroot/mozilla/netwerk/cookie/src/nsCookieService.cpp,v
retrieving revision 1.57
diff -p -U 8 -r1.57 nsCookieService.cpp
--- netwerk/cookie/src/nsCookieService.cpp	7 May 2007 11:14:01 -0000	1.57
+++ netwerk/cookie/src/nsCookieService.cpp	14 May 2007 09:24:21 -0000
@@ -2047,254 +1471,15 @@ nsCookieService::CheckPath(nsCookieAttri
 
   if (aCookieAttributes.path.Length() > kMaxBytesPerPath ||
       aCookieAttributes.path.FindChar('\t') != kNotFound )
     return PR_FALSE;
 
   return PR_TRUE;
 }
 
-PRBool
-nsCookieService::GetExpiry(nsCookieAttributes &aCookieAttributes,
-                           nsInt64            aServerTime,
-                           nsInt64            aCurrentTime,
-                           nsCookieStatus     aStatus)
-{
-  /* Determine when the cookie should expire. This is done by taking the difference between 
-   * the server time and the time the server wants the cookie to expire, and adding that 
-   * difference to the client time. This localizes the client time regardless of whether or
-   * not the TZ environment variable was set on the client.
-   *
-   * Note: We need to consider accounting for network lag here, per RFC.
-   */
-  nsInt64 delta;
-
-  // check for max-age attribute first; this overrides expires attribute
-  if (!aCookieAttributes.maxage.IsEmpty()) {
-    // obtain numeric value of maxageAttribute
-    PRInt64 maxage;
-    PRInt32 numInts = PR_sscanf(aCookieAttributes.maxage.get(), "%lld", &maxage);
-
-    // default to session cookie if the conversion failed
-    if (numInts != 1) {
-      return PR_TRUE;
-    }
-
-    delta = nsInt64(maxage);
-
-  // check for expires attribute
-  } else if (!aCookieAttributes.expires.IsEmpty()) {
-    nsInt64 expires;
-    PRTime tempExpires;
-
-    // parse expiry time
-    if (PR_ParseTimeString(aCookieAttributes.expires.get(), PR_TRUE, &tempExpires) == PR_SUCCESS) {
-      expires = nsInt64(tempExpires) / USEC_PER_SEC;
-    } else {
-      return PR_TRUE;
-    }
-
-    delta = expires - aServerTime;
-
-  // default to session cookie if no attributes found
-  } else {
-    return PR_TRUE;
-  }
-
-  // if this addition overflows, expiryTime will be less than currentTime
-  // and the cookie will be expired - that's okay.
-  aCookieAttributes.expiryTime = aCurrentTime + delta;
-
-  // we need to return whether the cookie is a session cookie or not:
-  // the cookie may have been previously downgraded by p3p prefs,
-  // so we take that into account here. only applies to non-expired cookies.
-  return aStatus == nsICookie::STATUS_DOWNGRADED &&
-         aCookieAttributes.expiryTime > aCurrentTime;
-}
-
-/******************************************************************************
- * nsCookieService impl:
- * private cookielist management functions
- ******************************************************************************/
-
-void
-nsCookieService::RemoveAllFromMemory()
-{
-  // clearing the hashtable will call each nsCookieEntry's dtor,
-  // which releases all their respective children.
-  mHostTable.Clear();
-  mCookieCount = 0;
-  mCookieChanged = PR_TRUE;
-}
-
-PLDHashOperator PR_CALLBACK
-removeExpiredCallback(nsCookieEntry *aEntry,
-                      void          *aArg)
-{
-  const nsInt64 &currentTime = *NS_STATIC_CAST(nsInt64*, aArg);
-  for (nsListIter iter(aEntry, nsnull, aEntry->Head()); iter.current; ) {
-    if (iter.current->Expiry() <= currentTime)
-      // remove from list. this takes care of updating the iterator for us
-      nsCookieService::gCookieService->RemoveCookieFromList(iter);
-    else
-      ++iter;
-  }
-  return PL_DHASH_NEXT;
-}
-
-// removes any expired cookies from memory
-void
-nsCookieService::RemoveExpiredCookies(nsInt64 aCurrentTime)
-{
-  mHostTable.EnumerateEntries(removeExpiredCallback, &aCurrentTime);
-}
-
-// find whether a given cookie has been previously set. this is provided by the
-// nsICookieManager2 interface.
-NS_IMETHODIMP
-nsCookieService::CookieExists(nsICookie2 *aCookie,
-                              PRBool     *aFoundCookie)
-{
-  NS_ENSURE_ARG_POINTER(aCookie);
-
-  // just a placeholder
-  nsEnumerationData data(NOW_IN_SECONDS, LL_MININT);
-  nsCookie *cookie = NS_STATIC_CAST(nsCookie*, aCookie);
-
-  *aFoundCookie = FindCookie(cookie->Host(), cookie->Name(), cookie->Path(), data.iter);
-  return NS_OK;
-}
-
-// count the number of cookies from a given host, and simultaneously find the
-// oldest cookie from the host.
-PRUint32
-nsCookieService::CountCookiesFromHostInternal(const nsACString  &aHost,
-                                              nsEnumerationData &aData)
-{
-  PRUint32 countFromHost = 0;
-
-  nsCAutoString hostWithDot(NS_LITERAL_CSTRING(".") + aHost);
-
-  const char *currentDot = hostWithDot.get();
-  const char *nextDot = currentDot + 1;
-  do {
-    nsCookieEntry *entry = mHostTable.GetEntry(currentDot);
-    for (nsListIter iter(entry); iter.current; ++iter) {
-      // only count non-expired cookies
-      if (iter.current->Expiry() > aData.currentTime) {
-        ++countFromHost;
-
-        // check if we've found the oldest cookie so far
-        if (aData.oldestTime > iter.current->LastAccessed()) {
-          aData.oldestTime = iter.current->LastAccessed();
-          aData.iter = iter;
-        }
-      }
-    }
-
-    currentDot = nextDot;
-    if (currentDot)
-      nextDot = strchr(currentDot + 1, '.');
-
-  } while (currentDot);
-
-  return countFromHost;
-}
-
-// count the number of cookies stored by a particular host. this is provided by the
-// nsICookieManager2 interface.
-NS_IMETHODIMP
-nsCookieService::CountCookiesFromHost(const nsACString &aHost,
-                                      PRUint32         *aCountFromHost)
-{
-  // we don't care about finding the oldest cookie here, so disable the search
-  nsEnumerationData data(NOW_IN_SECONDS, LL_MININT);
-  
-  *aCountFromHost = CountCookiesFromHostInternal(aHost, data);
-  return NS_OK;
-}
-
-// find an exact previous match.
-PRBool
-nsCookieService::FindCookie(const nsAFlatCString &aHost,
-                            const nsAFlatCString &aName,
-                            const nsAFlatCString &aPath,
-                            nsListIter           &aIter)
-{
-  nsCookieEntry *entry = mHostTable.GetEntry(aHost.get());
-  for (aIter = nsListIter(entry); aIter.current; ++aIter) {
-    if (aPath.Equals(aIter.current->Path()) &&
-        aName.Equals(aIter.current->Name())) {
-      return PR_TRUE;
-    }
-  }
-
-  return PR_FALSE;
-}
-
-// removes a cookie from the hashtable, and update the iterator state.
-void
-nsCookieService::RemoveCookieFromList(nsListIter &aIter)
-{
-  if (!aIter.prev && !aIter.current->Next()) {
-    // we're removing the last element in the list - so just remove the entry
-    // from the hash. note that the entryclass' dtor will take care of
-    // releasing this last element for us!
-    mHostTable.RawRemoveEntry(aIter.entry);
-    aIter.current = nsnull;
-
-  } else {
-    // just remove the element from the list, and increment the iterator
-    nsCookie *next = aIter.current->Next();
-    NS_RELEASE(aIter.current);
-    if (aIter.prev) {
-      // element to remove is not the head
-      aIter.current = aIter.prev->Next() = next;
-    } else {
-      // element to remove is the head
-      aIter.current = aIter.entry->Head() = next;
-    }
-  }
-
-  --mCookieCount;
-  mCookieChanged = PR_TRUE;
-}
-
-PRBool
-nsCookieService::AddCookieToList(nsCookie *aCookie)
-{
-  nsCookieEntry *entry = mHostTable.PutEntry(aCookie->Host().get());
-
-  if (!entry) {
-    NS_ERROR("can't insert element into a null entry!");
-    return PR_FALSE;
-  }
-
-  NS_ADDREF(aCookie);
-
-  aCookie->Next() = entry->Head();
-  entry->Head() = aCookie;
-  ++mCookieCount;
-  mCookieChanged = PR_TRUE;
-
-  return PR_TRUE;
-}
-
-PR_STATIC_CALLBACK(PLDHashOperator)
-findOldestCallback(nsCookieEntry *aEntry,
-                   void          *aArg)
-{
-  nsEnumerationData *data = NS_STATIC_CAST(nsEnumerationData*, aArg);
-  for (nsListIter iter(aEntry, nsnull, aEntry->Head()); iter.current; ++iter) {
-    // check if we've found the oldest cookie so far
-    if (data->oldestTime > iter.current->LastAccessed()) {
-      data->oldestTime = iter.current->LastAccessed();
-      data->iter = iter;
-    }
-  }
-  return PL_DHASH_NEXT;
-}
-
+// notify observers that a cookie was rejected due to the users' prefs.
 void
-nsCookieService::FindOldestCookie(nsEnumerationData &aData)
+nsCookieService::NotifyRejected(nsIURI *aHostURI, const PRUnichar *aData)
 {
-  mHostTable.EnumerateEntries(findOldestCallback, &aData);
+  if (mObserverService)
+    mObserverService->NotifyObservers(aHostURI, "cookie-rejected", aData);
 }
Index: netwerk/cookie/src/nsCookieService.h
===================================================================
RCS file: /cvsroot/mozilla/netwerk/cookie/src/nsCookieService.h,v
retrieving revision 1.25
diff -p -U 8 -r1.25 nsCookieService.h
--- netwerk/cookie/src/nsCookieService.h	5 May 2007 21:09:54 -0000	1.25
+++ netwerk/cookie/src/nsCookieService.h	14 May 2007 09:24:22 -0000
@@ -17,16 +17,17 @@
  * The Initial Developer of the Original Code is
  * Netscape Communications Corporation.
  * Portions created by the Initial Developer are Copyright (C) 2003
  * the Initial Developer. All Rights Reserved.
  *
  * Contributor(s):
  *   Daniel Witte (dwitte@stanford.edu)
  *   Michiel van Leeuwen (mvl@exedo.nl)
+ *   Loune Lam (lpgcritter at nasquan dot com)
  *
  * Alternatively, the contents of this file may be used under the terms of
  * either the GNU General Public License Version 2 or later (the "GPL"), or
  * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
  * in which case the provisions of the GPL or the LGPL are applicable instead
  * of those above. If you wish to allow use of your version of this file only
  * under the terms of either the GPL or the LGPL, and not to allow others to
  * use your version of this file under the terms of the MPL, indicate your
@@ -35,195 +36,93 @@
  * the provisions above, a recipient may use your version of this file under
  * the terms of any one of the MPL, the GPL or the LGPL.
  *
  * ***** END LICENSE BLOCK ***** */
 
 #ifndef nsCookieService_h__
 #define nsCookieService_h__
 
-#include "nsICookieServiceInternal.h"
 #include "nsICookieManager.h"
 #include "nsICookieManager2.h"
+#include "nsICookieContainer.h"
+#include "nsICookieService.h"
 #include "nsIObserver.h"
 #include "nsWeakReference.h"
 
 #include "nsCookie.h"
 #include "nsString.h"
 #include "nsTHashtable.h"
+#include "nsInterfaceHashtable.h"
+#include "nsHashKeys.h"
 
 #include "nsInt64.h"
 
 struct nsCookieAttributes;
 struct nsListIter;
 struct nsEnumerationData;
 
-class nsAutoVoidArray;
-
 class nsIPrefBranch;
 class nsICookieConsent;
 class nsICookiePermission;
 class nsIPrefBranch;
 class nsIObserverService;
 class nsIURI;
 class nsIChannel;
-class nsITimer;
-class nsIFile;
-
-// hash entry class
-class nsCookieEntry : public PLDHashEntryHdr
-{
-  public:
-    // Hash methods
-    typedef const char* KeyType;
-    typedef const char* KeyTypePointer;
-
-    // do nothing with aHost - we require mHead to be set before we're live!
-    nsCookieEntry(KeyTypePointer aHost)
-     : mHead(nsnull)
-    {
-    }
-
-    nsCookieEntry(const nsCookieEntry& toCopy)
-    {
-      // if we end up here, things will break. nsTHashtable shouldn't
-      // allow this, since we set ALLOW_MEMMOVE to true.
-      NS_NOTREACHED("nsCookieEntry copy constructor is forbidden!");
-    }
-
-    ~nsCookieEntry()
-    {
-      // walk the linked list, and de-link everything by releasing & nulling.
-      // this allows the parent host entry to be deleted by the hashtable.
-      // note: we know mHead cannot be null here - we always set mHead to a
-      // valid nsCookie (if it were null, the hashtable wouldn't be able to find
-      // this entry, because the key string is provided by mHead).
-      nsCookie *current = mHead, *next;
-      do {
-        next = current->Next();
-        NS_RELEASE(current);
-      } while ((current = next));
-    }
-
-    KeyType GetKey() const
-    {
-      return HostPtr();
-    }
-
-    PRBool KeyEquals(KeyTypePointer aKey) const
-    {
-      return !strcmp(HostPtr(), aKey);
-    }
-
-    static KeyTypePointer KeyToPointer(KeyType aKey)
-    {
-      return aKey;
-    }
-
-    static PLDHashNumber HashKey(KeyTypePointer aKey)
-    {
-      // PL_DHashStringKey doesn't use the table parameter, so we can safely
-      // pass nsnull
-      return PL_DHashStringKey(nsnull, aKey);
-    }
-
-    enum { ALLOW_MEMMOVE = PR_TRUE };
-
-    // get methods
-    inline const nsDependentCString Host() const { return mHead->Host(); }
-
-    // linked list management helper
-    inline nsCookie*& Head() { return mHead; }
-
-    inline KeyTypePointer HostPtr() const
-    {
-      return mHead->Host().get();
-    }
-
-  private:
-    nsCookie *mHead;
-};
 
 /******************************************************************************
  * nsCookieService:
  * class declaration
  ******************************************************************************/
 
-class nsCookieService : public nsICookieServiceInternal
-                      , public nsICookieManager2
+class nsCookieService : public nsICookieService
                       , public nsIObserver
                       , public nsSupportsWeakReference
 {
   public:
     // nsISupports
     NS_DECL_ISUPPORTS
     NS_DECL_NSIOBSERVER
     NS_DECL_NSICOOKIESERVICE
-    NS_DECL_NSICOOKIESERVICEINTERNAL
-    NS_DECL_NSICOOKIEMANAGER
-    NS_DECL_NSICOOKIEMANAGER2
 
     nsCookieService();
     virtual ~nsCookieService();
     static nsCookieService*       GetSingleton();
+    static NS_METHOD              GetDefaultContainer(nsISupports* aOuter, const nsIID& aIID, void* *aResult);
     nsresult                      Init();
 
   protected:
-    void                          PrefChanged(nsIPrefBranch *aPrefBranch);
-    nsresult                      Read();
-    nsresult                      Write();
-    void                          GetCookieList(nsIURI *aHostURI, nsIURI *aFirstURI, nsIChannel *aChannel, const nsACString *aName, PRBool isHttpBound, nsAutoVoidArray &aResult);
-    char*                         CookieStringFromArray(const nsAutoVoidArray& aCookieList, nsIURI *aHostURI);
-    PRBool                        SetCookieInternal(nsIURI *aHostURI, nsIChannel *aChannel, nsDependentCString &aCookieHeader, nsInt64 aServerTime, nsCookieStatus aStatus, nsCookiePolicy aPolicy);
-    void                          CheckAndAdd(nsIURI *aHostURI, nsIChannel *aChannel, nsCookieAttributes &aAttributes, nsCookieStatus aStatus, nsCookiePolicy aPolicy, const nsAFlatCString &aCookieHeader);
-    void                          AddInternal(nsCookie *aCookie, nsInt64 aCurrentTime, nsIURI *aHostURI, const char *aCookieHeader);
-    void                          RemoveCookieFromList(nsListIter &aIter);
-    PRBool                        AddCookieToList(nsCookie *aCookie);
+
+    char*                         CookieStringFromArray(nsIArray* aCookieList, nsIURI *aHostURI);
+    PRBool                        SetCookieInternal(nsICookieContainer *aContainer, nsIURI *aHostURI, nsIChannel *aChannel, nsDependentCString &aCookieHeader, nsInt64 aServerTime, nsCookieStatus aStatus, nsCookiePolicy aPolicy);
+    void                          CheckAndAdd(nsICookieContainer *aContainer, nsIURI *aHostURI, nsIChannel *aChannel, nsCookieAttributes &aAttributes, nsCookieStatus aStatus, nsCookiePolicy aPolicy, const nsAFlatCString &aCookieHeader);
     static PRBool                 GetTokenValue(nsASingleFragmentCString::const_char_iterator &aIter, nsASingleFragmentCString::const_char_iterator &aEndIter, nsDependentCSubstring &aTokenString, nsDependentCSubstring &aTokenValue, PRBool &aEqualsFound);
     static PRBool                 ParseAttributes(nsDependentCString &aCookieHeader, nsCookieAttributes &aCookie);
+    static PRBool                 GetExpiry(nsCookieAttributes &aCookie, nsInt64 aServerTime, nsInt64 aCurrentTime, nsCookieStatus aStatus);
+ 
     static PRBool                 IsIPAddress(const nsAFlatCString &aHost);
     static PRBool                 IsInDomain(const nsACString &aDomain, const nsACString &aHost, PRBool aIsDomain = PR_TRUE);
     static PRBool                 IsForeign(nsIURI *aHostURI, nsIURI *aFirstURI);
-    nsCookieStatus                CheckPrefs(nsIURI *aHostURI, nsIURI *aFirstURI, nsIChannel *aChannel, const char *aCookieHeader, nsCookiePolicy &aPolicy);
+    nsCookieStatus                CheckPrefs(nsICookiePermission *aPermissionService, nsIURI *aHostURI, nsIURI *aFirstURI, nsIChannel *aChannel, const char *aCookieHeader, nsCookiePolicy &aPolicy);
     static PRBool                 CheckDomain(nsCookieAttributes &aCookie, nsIURI *aHostURI);
     static PRBool                 CheckPath(nsCookieAttributes &aCookie, nsIURI *aHostURI);
-    static PRBool                 GetExpiry(nsCookieAttributes &aCookie, nsInt64 aServerTime, nsInt64 aCurrentTime, nsCookieStatus aStatus);
-    void                          RemoveAllFromMemory();
-    void                          RemoveExpiredCookies(nsInt64 aCurrentTime);
-    PRBool                        FindCookie(const nsAFlatCString &aHost, const nsAFlatCString &aName, const nsAFlatCString &aPath, nsListIter &aIter);
-    void                          FindOldestCookie(nsEnumerationData &aData);
-    PRUint32                      CountCookiesFromHostInternal(const nsACString &aHost, nsEnumerationData &aData);
-    void                          NotifyRejected(nsIURI *aHostURI);
-    void                          NotifyChanged(nsICookie2 *aCookie, const PRUnichar *aData);
-
-    // Use LazyWrite to save the cookies file on a timer. It will write
-    // the file only once if repeatedly hammered quickly.
-    void                          LazyWrite();
-    static void                   DoLazyWrite(nsITimer *aTimer, void *aClosure);
 
+    void                          NotifyRejected(nsIURI *aHostURI, const PRUnichar *aData);
   protected:
     // cached members
-    nsCOMPtr<nsIFile>             mCookieFile;
     nsCOMPtr<nsIObserverService>  mObserverService;
     nsCOMPtr<nsICookieConsent>    mP3PService;
     nsCOMPtr<nsICookiePermission> mPermissionService;
 
     // impl members
-    nsCOMPtr<nsITimer>            mWriteTimer;
-    nsTHashtable<nsCookieEntry>   mHostTable;
-    PRUint32                      mCookieCount;
-    PRPackedBool                  mCookieChanged;
+    nsInterfaceHashtable<nsCharPtrHashKey, nsICookieContainer> mContainerTable;
     PRPackedBool                  mCookieIconVisible;
+	nsCString                     mDefaultContainerId;
 
     // cached prefs
     PRUint8                       mCookiesPermissions;   // BEHAVIOR_{ACCEPT, REJECTFOREIGN, REJECT, P3P}
-    PRUint16                      mMaxNumberOfCookies;
-    PRUint16                      mMaxCookiesPerHost;
 
     // private static member, used to cache a ptr to nsCookieService,
     // so we can make nsCookieService a singleton xpcom object.
     static nsCookieService        *gCookieService;
-
-    // this callback needs access to member functions
-    friend PLDHashOperator PR_CALLBACK removeExpiredCallback(nsCookieEntry *aEntry, void *aArg);
 };
 
 #endif // nsCookieService_h__
Index: netwerk/protocol/http/src/nsHttpChannel.cpp
===================================================================
RCS file: /cvsroot/mozilla/netwerk/protocol/http/src/nsHttpChannel.cpp,v
retrieving revision 1.308
diff -p -U 8 -r1.308 nsHttpChannel.cpp
--- netwerk/protocol/http/src/nsHttpChannel.cpp	13 May 2007 17:09:51 -0000	1.308
+++ netwerk/protocol/http/src/nsHttpChannel.cpp	14 May 2007 09:24:36 -0000
@@ -115,16 +115,17 @@ nsHttpChannel::nsHttpChannel()
     , mCanceled(PR_FALSE)
     , mTransactionReplaced(PR_FALSE)
     , mUploadStreamHasHeaders(PR_FALSE)
     , mAuthRetryPending(PR_FALSE)
     , mSuppressDefensiveAuth(PR_FALSE)
     , mResuming(PR_FALSE)
     , mInitedCacheEntry(PR_FALSE)
     , mCacheForOfflineUse(PR_FALSE)
+    , mCookieContainer(nsnull)
 {
     LOG(("Creating nsHttpChannel @%x\n", this));
 
     // grab a reference to the handler to ensure that it doesn't go away.
     nsHttpHandler *handler = gHttpHandler;
     NS_ADDREF(handler);
 }
 
@@ -224,16 +225,22 @@ nsHttpChannel::Init(nsIURI *uri,
     rv = mRequestHead.SetHeader(nsHttp::Host, hostLine);
     if (NS_FAILED(rv)) return rv;
 
     rv = gHttpHandler->
         AddStandardRequestHeaders(&mRequestHead.Headers(), caps,
                                   !mConnectionInfo->UsingSSL() &&
                                   mConnectionInfo->UsingHttpProxy());
 
+    // set to the default cookie container
+    nsICookieService *cs = gHttpHandler->GetCookieService();
+    nsCOMPtr<nsICookieContainer> container;
+    cs->GetDefaultContainer(getter_AddRefs(container));
+    SetCookieContainer(container);
+
     return rv;
 }
 
 //-----------------------------------------------------------------------------
 // nsHttpChannel <private>
 //-----------------------------------------------------------------------------
 
 nsresult
@@ -583,17 +590,18 @@ nsHttpChannel::SetupTransaction()
 
 void
 nsHttpChannel::AddCookiesToRequest()
 {
     nsXPIDLCString cookie;
 
     nsICookieService *cs = gHttpHandler->GetCookieService();
     if (cs)
-        cs->GetCookieStringFromHttp(mURI,
+        cs->GetCookieStringFromHttp(mCookieContainer,
+                                    mURI,
                                     mDocumentURI ? mDocumentURI : mOriginalURI,
                                     this,
                                     getter_Copies(cookie));
     if (cookie.IsEmpty())
         cookie = mUserSetCookieHeader;
     else if (!mUserSetCookieHeader.IsEmpty())
         cookie.Append(NS_LITERAL_CSTRING("; ") + mUserSetCookieHeader);
 
@@ -2118,16 +2126,22 @@ nsHttpChannel::SetupReplacementChannel(n
     if (mConnectionInfo->UsingSSL())
         newLoadFlags &= ~INHIBIT_PERSISTENT_CACHING;
 
     newChannel->SetOriginalURI(mOriginalURI);
     newChannel->SetLoadGroup(mLoadGroup); 
     newChannel->SetNotificationCallbacks(mCallbacks);
     newChannel->SetLoadFlags(newLoadFlags);
 
+    // set the new channel cookie container to that of this channel
+    nsCOMPtr<nsICookieCollector> cookieCollector(do_QueryInterface(newChannel));
+    if (cookieCollector) {
+        cookieCollector->SetCookieContainer(mCookieContainer);
+    }
+
     nsCOMPtr<nsIHttpChannel> httpChannel = do_QueryInterface(newChannel);
     if (!httpChannel)
         return NS_OK; // no other options to set
 
     if (preserveMethod) {
         nsCOMPtr<nsIUploadChannel> uploadChannel = do_QueryInterface(httpChannel);
         if (mUploadStream && uploadChannel) {
             // rewind upload stream
@@ -3228,16 +3242,17 @@ NS_INTERFACE_MAP_BEGIN(nsHttpChannel)
     NS_INTERFACE_MAP_ENTRY(nsICacheListener)
     NS_INTERFACE_MAP_ENTRY(nsIEncodedChannel)
     NS_INTERFACE_MAP_ENTRY(nsIHttpChannelInternal)
     NS_INTERFACE_MAP_ENTRY(nsIResumableChannel)
     NS_INTERFACE_MAP_ENTRY(nsITransportEventSink)
     NS_INTERFACE_MAP_ENTRY(nsISupportsPriority)
     NS_INTERFACE_MAP_ENTRY(nsIProtocolProxyCallback)
     NS_INTERFACE_MAP_ENTRY(nsIProxiedChannel)
+    NS_INTERFACE_MAP_ENTRY(nsICookieCollector)
 NS_INTERFACE_MAP_END_INHERITING(nsHashPropertyBag)
 
 //-----------------------------------------------------------------------------
 // nsHttpChannel::nsIRequest
 //-----------------------------------------------------------------------------
 
 NS_IMETHODIMP
 nsHttpChannel::GetName(nsACString &aName)
@@ -4061,17 +4076,18 @@ nsHttpChannel::SetCookie(const char *aCo
         return NS_OK;
 
     nsICookieService *cs = gHttpHandler->GetCookieService();
     NS_ENSURE_TRUE(cs, NS_ERROR_FAILURE);
 
     nsCOMPtr<nsIPrompt> prompt;
     GetCallback(prompt);
 
-    return cs->SetCookieStringFromHttp(mURI,
+    return cs->SetCookieStringFromHttp(mCookieContainer,
+                                       mURI,
                                        mDocumentURI ? mDocumentURI : mOriginalURI,
                                        prompt,
                                        aCookieHeader,
                                        mResponseHead->PeekHeader(nsHttp::Date),
                                        this);
 }
 
 //-----------------------------------------------------------------------------
@@ -4842,8 +4858,29 @@ nsHttpChannel::nsContentEncodings::Prepa
                                              nsCaseInsensitiveCStringComparator())) {
         mCurEnd = mCurStart;
         return PrepareForNext();
     }
         
     mReady = PR_TRUE;
     return NS_OK;
 }
+
+
+//-----------------------------------------------------------------------------
+// nsHttpChannel::nsICookieCollector
+//-----------------------------------------------------------------------------
+/* attribute nsICookieContainer cookieContainer; */
+NS_IMETHODIMP
+nsHttpChannel::GetCookieContainer(nsICookieContainer * *aCookieContainer)
+{
+    NS_ENSURE_ARG_POINTER(aCookieContainer);
+	*aCookieContainer = mCookieContainer;
+    NS_IF_ADDREF(*aCookieContainer);
+    return NS_OK;
+}
+NS_IMETHODIMP
+nsHttpChannel::SetCookieContainer(nsICookieContainer * aCookieContainer)
+{
+    mCookieContainer = aCookieContainer;
+    return NS_OK;
+}
+
Index: netwerk/protocol/http/src/nsHttpChannel.h
===================================================================
RCS file: /cvsroot/mozilla/netwerk/protocol/http/src/nsHttpChannel.h,v
retrieving revision 1.89
diff -p -U 8 -r1.89 nsHttpChannel.h
--- netwerk/protocol/http/src/nsHttpChannel.h	23 Mar 2007 21:56:32 -0000	1.89
+++ netwerk/protocol/http/src/nsHttpChannel.h	14 May 2007 09:24:37 -0000
@@ -75,16 +75,18 @@
 #include "nsIOutputStream.h"
 #include "nsIAsyncInputStream.h"
 #include "nsIPrompt.h"
 #include "nsIResumableChannel.h"
 #include "nsISupportsPriority.h"
 #include "nsIProtocolProxyCallback.h"
 #include "nsICancelable.h"
 #include "nsIProxiedChannel.h"
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
 
 class nsHttpResponseHead;
 class nsAHttpConnection;
 class nsIHttpAuthenticator;
 class nsProxyInfo;
 
 //-----------------------------------------------------------------------------
 // nsHttpChannel
@@ -98,16 +100,17 @@ class nsHttpChannel : public nsHashPrope
                     , public nsIUploadChannel
                     , public nsICacheListener
                     , public nsIEncodedChannel
                     , public nsITransportEventSink
                     , public nsIResumableChannel
                     , public nsISupportsPriority
                     , public nsIProtocolProxyCallback
                     , public nsIProxiedChannel
+                    , public nsICookieCollector
 {
 public:
     NS_DECL_ISUPPORTS_INHERITED
     NS_DECL_NSIREQUEST
     NS_DECL_NSICHANNEL
     NS_DECL_NSIHTTPCHANNEL
     NS_DECL_NSIREQUESTOBSERVER
     NS_DECL_NSISTREAMLISTENER
@@ -116,16 +119,17 @@ public:
     NS_DECL_NSICACHELISTENER
     NS_DECL_NSIENCODEDCHANNEL
     NS_DECL_NSIHTTPCHANNELINTERNAL
     NS_DECL_NSITRANSPORTEVENTSINK
     NS_DECL_NSIRESUMABLECHANNEL
     NS_DECL_NSISUPPORTSPRIORITY
     NS_DECL_NSIPROTOCOLPROXYCALLBACK
     NS_DECL_NSIPROXIEDCHANNEL
+    NS_DECL_NSICOOKIECOLLECTOR
 
     nsHttpChannel();
     virtual ~nsHttpChannel();
 
     nsresult Init(nsIURI *uri,
                   PRUint8 capabilities,
                   nsProxyInfo* proxyInfo);
 
@@ -221,16 +225,18 @@ private:
     nsCOMPtr<nsISupports>             mOwner;
     nsCOMPtr<nsIInterfaceRequestor>   mCallbacks;
     nsCOMPtr<nsIProgressEventSink>    mProgressSink;
     nsCOMPtr<nsIInputStream>          mUploadStream;
     nsCOMPtr<nsIURI>                  mReferrer;
     nsCOMPtr<nsISupports>             mSecurityInfo;
     nsCOMPtr<nsICancelable>           mProxyRequest;
 
+    nsCOMPtr<nsICookieContainer>      mCookieContainer;
+
     nsHttpRequestHead                 mRequestHead;
     nsHttpResponseHead               *mResponseHead;
 
     nsRefPtr<nsInputStreamPump>       mTransactionPump;
     nsHttpTransaction                *mTransaction;     // hard ref
     nsHttpConnectionInfo             *mConnectionInfo;  // hard ref
 
     nsCString                         mSpec; // ASCII encoded URL spec
